
/******************************************************************************
* MODULE     : interval_neg.cpp
* DESCRIPTION: Compute opposite interval
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "interval_impl.hpp"
namespace mml {

interval
operator - (const interval& x) {
  if (is_error (x)) return x;
  interval r= raw_interval (prec (x));
  if (has_low_prec (x)) {
    mpfr_neg (r->min, x->max, GMP_RNDD);
    mpfr_neg (r->max, x->min, GMP_RNDU);
  }
  else {
    mpfr_neg (r->mid, x->mid, GMP_RNDN);
    mpfr_set (r->rad, x->rad, GMP_RNDU);
  }
  return r;
}

} // namespace mml
