
/******************************************************************************
* MODULE     : real_test.cc
* DESCRIPTION: Test real numbers
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "real.hpp"
using namespace mml;

int
main () {
  real x (1), y (2);
  cout << x << "\t0\t" << x->approx (1.0) << "\n";
  cout << x << "\t40\t" << x->approx (1.0e-40) << "\n";
  cout << x << "\t20\t" << x->approx (1.0e-20) << "\n";
  cout << x << "\t45\t" << x->approx (1.0e-45) << "\n";
  cout << x << "\t46\t" << x->approx (1.0e-46) << "\n";
  cout << x << "\t100\t" << x->approx (1.0e-100) << "\n";
  x= 4;
  y= x+x;
  cout << x << "\t50\t" << x->approx (1.0e-50) << "\n";
  cout << y << "\t0\t" << y->approx (1.0) << "\n";
  cout << y << "\t40\t" << y->approx (1.0e-40) << "\n";
  cout << y << "\t50\t" << y->approx (1.0e-50) << "\n";
  y= x-x;
  cout << x << "\t50\t" << x->approx (1.0e-50) << "\n";
  cout << y << "\t0\t" << y->approx (1.0) << "\n";
  cout << y << "\t40\t" << y->approx (1.0e-40) << "\n";
  cout << y << "\t50\t" << y->approx (1.0e-50) << "\n";
  y= x*x;
  cout << x << "\t50\t" << x->approx (1.0e-50) << "\n";
  cout << y << "\t0\t" << y->approx (1.0) << "\n";
  cout << y << "\t40\t" << y->approx (1.0e-40) << "\n";
  cout << y << "\t50\t" << y->approx (1.0e-50) << "\n";
  y= real(0)*x;
  cout << x << "\t50\t" << x->approx (1.0e-50) << "\n";
  cout << y << "\t0\t" << y->approx (1.0) << "\n";
  cout << y << "\t40\t" << y->approx (1.0e-40) << "\n";
  cout << y << "\t50\t" << y->approx (1.0e-50) << "\n";
  y= x/x;
  cout << x << "\t50\t" << x->approx (1.0e-50) << "\n";
  cout << y << "\t0\t" << y->approx (1.0) << "\n";
  cout << y << "\t40\t" << y->approx (1.0e-40) << "\n";
  cout << y << "\t50\t" << y->approx (1.0e-50) << "\n";
  /*
  y= x/(x-x);
  cout << y << "\t0\t" << y->approx (1.0) << "\n";
  */
  y= -x;
  cout << x << "\t50\t" << x->approx (1.0e-50) << "\n";
  cout << y << "\t20\t" << y->approx (1.0e-20) << "\n";
  cout << y << "\t50\t" << y->approx (1.0e-50) << "\n";
  x= -3;
  y= abs (x);
  cout << x << "\t\t50\t" << x->approx (1.0e-50) << "\n";
  cout << y << "\t20\t" << y->approx (1.0e-20) << "\n";
  cout << y << "\t50\t" << y->approx (1.0e-50) << "\n";
  x= 3;
  y= x << 10;
  cout << x << "\t\t50\t" << x->approx (1.0e-50) << "\n";
  cout << y << "\t20\t" << y->approx (1.0e-20) << "\n";
  cout << y << "\t50\t" << y->approx (1.0e-50) << "\n";
  y= x >> 10;
  cout << x << "\t\t50\t" << x->approx (1.0e-50) << "\n";
  cout << y << "\t20\t" << y->approx (1.0e-20) << "\n";
  cout << y << "\t50\t" << y->approx (1.0e-50) << "\n";
  x= 3;
  y= 4;
  cout << "x\t= " << x << "\n";
  cout << "y\t= " << y << "\n";
  cout << "x=x\t= " << (x==x) << "\n";
  cout << "x<x\t= " << (x<x) << "\n";
  cout << "x<=x\t= " << (x<=x) << "\n";
  cout << "x=y\t= " << (x==y) << "\n";
  cout << "x!=y\t= " << (x!=y) << "\n";
  cout << "x<y\t= " << (x<y) << "\n";
  cout << "x<=y\t= " << (x<=y) << "\n";
  cout << "x>y\t= " << (x>y) << "\n";
  cout << "x>=y\t= " << (x>=y) << "\n";
  return 0;
}
